
read("../../../lib/nearest_singular_poly_functions.mpl"):
read("../../../lib/alpha_optimization.mpl"): #needed for Levenberg-Marquardt
read("../../../lib/nearest_smith_functions.mpl"): #needed for approximate GCD

with(NearestPoly):
with(AlphaOptimization):
with(NearestSmith):

read("../../../lib/numeric_poly_linalg.mpl"): #needed for some kernel stuff

read("../../../lib/SQP_solvers.mpl"): #Needed for SLN-newton

#here we try to replicate Example 2.10 with real perturbations

aa:= LinearAlgebra:-Transpose(<0, 0.0400, 0.8900 | 0.1500 , -0.0200, 0 | 0.9200, 0.1100, 0.06600>);
ee:= <0,0,0|0,0,1|0,1,0>;

AA:= collect(aa+t*ee,t);


n:= LinearAlgebra:-RowDimension(AA);
d:=matrix_degree(AA,t);





Digits:=35:

#perturb all coefficients
#DA, DA_vars := generate_dense_unstructured_perturbation(AA, t); #same experiment as the paper 2.12

#only perturb trailing coefficients

DA, DA_vars := generate_dense_unstructured_perturbation(AA, t); #same experiment as the paper 2.12

#DA, DA_vars := generate_unstructured_perturbation(aa, t); #same experiment as the paper 2.10
#DA, DA_vars := generate_perturbation(AA, t,"support"); #same experiment as the paper 2.12 but with support.
#DA, DA_vars := generate_perturbation(AA+aa_init, t,"entry"); #same experiment as the paper 2.12 but with entry degrees.


AA_init := AA; #NOTE THAT WE USE A FOR THE INITIAL GUESS


A_lin := linearize_A(evalf(AA_init),t)[1]:
K:= compute_orthonormal_kernel(A_lin,1e-2);
b_init_lin :=  extract_minimally_embedded_kernel_vector(K); #here be a minimally embedded vector!

#floating point noise is gone...
b_init := devectorize(b_init_lin,n,d,t,1e-3);
printlevel:=2;
b_init := force_columns_prim(Matrix(b_init),t);
K_init:= convert(simplify(compute_matrix_poly_kernel(AA_init,t)),Matrix): #WARNING the columns need to be re-scaled.

K_init := force_columns_prim(Matrix(K_init));


z1:= singular_poly_sqp_dbg(AA,DA,DA_vars,AA_init,b_init,1000,1e-14,1e14,"vanilla"):

z2:= singular_poly_sqp_dbg(AA,DA,DA_vars,AA_init,b_init,1000,1e-14,1e14,"sln"):
z3:= singular_poly_sqp_dbg(AA,DA,DA_vars,AA_init,b_init,1000,1e-14,1e14,"lm"):


z4 := constrained_newton_arbitrary(AA, DA, DA_vars, AA_init, b_init, 15, 0.1e-24,1e6):


z:=z4:
A_opt_lin := linearize_A(AA+subs(z[4],DA),t)[1];
K_opt := compute_orthonormal_kernel(A_opt_lin,1e-4);
b_opt_lin := extract_minimally_embedded_kernel_vector(K_opt);
b_opt := devectorize(b_opt_lin,n,d,t,1e-20);

poly_norm_opt((AA+subs(z[4],DA)).b_opt,t), poly_norm_opt(subs(z[4],DA),t); #VICTORY?
poly_norm_opt(AA_init.b_init,t);
poly_norm_opt(AA_init -AA,t);

#poly_norm_opt(aa_init.b_opt,t);

#poly_norm_opt(ee_init.b_opt,t);



poly_norm_opt(subs(z1[4],DA),t);
poly_norm_opt(subs(z2[4],DA),t);
poly_norm_opt(subs(z3[4],DA),t);
poly_norm_opt(subs(z4[4],DA),t);

b_opt := force_columns_prim(Matrix(b_opt),t); #just remove content from the weird shifted normalization
evalf(%,5);
latex(%);
evalf(b_init,5);
latex(%);
evalf(subs(z[4],DA),5);
latex(%);
poly_norm_opt(subs(z[4],DA),t);

poly_norm_opt(AA-AA_init,t);
#poly_norm_opt(aa_init-aa,t);
#poly_norm_opt(ee_init-ee,t);


latex(ee);
latex(aa);
latex(DA);