
read("../../../lib/nearest_singular_poly_functions.mpl"):
read("../../../lib/alpha_optimization.mpl"): #needed for Levenberg-Marquardt
read("../../../lib/nearest_smith_functions.mpl"): #needed for approximate GCD

with(NearestPoly):
with(AlphaOptimization):
with(NearestSmith):

read("../../../lib/numeric_poly_linalg.mpl"): #needed for some kernel stuff

read("../../../lib/SQP_solvers.mpl"): #Needed for SLN-newton


#here we try to replicate Example 2.10 with real perturbations

aa:= LinearAlgebra:-Transpose(<0, 0.0400, 0.8900 | 0.1500 , -0.0200, 0 | 0.9200, 0.1100, 0.06600>);
ee:= <0,0,0|0,0,1|0,1,0>;

AA:= collect(aa+t*ee,t);


n:= LinearAlgebra:-RowDimension(AA);
d:=matrix_degree(AA,t);


#perturb all coefficients
DA, DA_vars := generate_perturbation(AA, t,"degree"); #same experiment as the paper 2.11


AA_init := AA;
aa_init := <-1.6212384085, 1.0469394294,-0.9441526182 |
	  0.3554202002,-0.2266297260,0.2179904923|
	  -0.5130886135, 0.5965969015,0.7121049288>;
ee_init := <0,0,0|
	    0.1271034578, 0.1505583462,0.9605965130|
	    -0.4844321165,0.4262604190,0.1501681259>;

AA_init := aa_init + t*ee_init;
Digits:=35:

#only perturb trailing coefficients
DA, DA_vars := generate_perturbation(aa, t,"support"); #same experiment as the paper 2.11
AA_init := AA;


A_lin := linearize_A(evalf(AA_init),t)[1]:
K:= compute_orthonormal_kernel(A_lin,1e-2);
b_init_lin :=  extract_minimally_embedded_kernel_vector(K); #here be a minimally embedded vector!

#floating point noise is gone...
b_init := devectorize(b_init_lin,n,d,t,1e-3);



z := constrained_newton_arbitrary(AA, DA, DA_vars, AA_init, b_init, 15, 0.1e-24,1e6):



sqrt(z[1]);

A_opt_lin := linearize_A(AA+subs(z[4],DA),t)[1];
K_opt := compute_orthonormal_kernel(A_opt_lin,1e-4);
b_opt_lin := extract_minimally_embedded_kernel_vector(K_opt);
b_opt := devectorize(b_opt_lin,n,d,t,1e-20);

poly_norm_opt((AA+subs(z[4],DA)).b_opt,t), poly_norm_opt(subs(z[4],DA),t); #VICTORY?
poly_norm_opt(AA_init.b_init,t);
poly_norm_opt(AA_init -AA,t);

poly_norm_opt(aa_init.b_opt,t);

poly_norm_opt(ee_init.b_opt,t);

evalf([subs(z[4],DA)+AA,subs(z[4],DA)] ,5);
