
read("../../../lib/nearest_singular_poly_functions.mpl"):
read("../../../lib/alpha_optimization.mpl"): #needed for Levenberg-Marquardt
read("../../../lib/nearest_smith_functions.mpl"): #needed for approximate GCD

with(NearestPoly):
with(AlphaOptimization):
with(NearestSmith):

read("../../../lib/numeric_poly_linalg.mpl"): #needed for some kernel stuff

read("../../../lib/SQP_solvers.mpl"): #Needed for SLN-newton

A:= <t+1,t-3,t,t-1| t+2,1,3,t-4>.<t+3,1|t^2-1,t-1|4,t+8|t-1,t+1>: #does not "work" for a queer reason


#A:= <1,t-3,1,0| t+2,1,3,1>.<t+3,1|t-1,t-1|4,8|t,t-1>: #this example works for some reason.

#A:= <t+1,t-3,t,t-1>.<t+3|t^2-1|4|t+1>: #best test example so far



A_init := A: #for now...


K_init:= convert(simplify(compute_matrix_poly_kernel(A,t)),Matrix): #WARNING the columns need to be re-scaled.


m,n := LinearAlgebra:-Dimension(K_init):
printlevel:=2:

DA, DA_vars := generate_unstructured_perturbation(A, t,'QQ'):
default_DeltaA_pt:= [seq(DA_vars[i]=0,i=1..nops(DA_vars))]:



#S:= generalized_sylvester_matrix(convert(K_init[1..m,2],list))[1];



K_init;
K_init := force_columns_prim(K_init,t);


poly_norm_opt(A.K_init,t); #it is indeed a kernel!

DA, DA_vars := generate_unstructured_perturbation(A, t,'QQ'): #less QQ more pew pew?
default_DeltaA_pt:= [seq(DA_vars[i]=0,i=1..nops(DA_vars))]:

with(LinearAlgebra):

A_noise := subs(random_pt(DA_vars),DA):

A_noise := A_noise/evalf(poly_norm_opt(A_noise,t)) *1e-3: #1e-7 works...
#quit;

#A_noise := evalf(collect(A,t),2) * 1e-1;

poly_norm_opt(A_noise,t);
poly_norm_opt(A,t);



K_init := `<|>`(op(NullSpace(A)));
K_init :=collect(simplify( K_init * denom(K_init[2,1])),t);



K_init := evalf(K_init);
poly_norm_opt(A.K_init,t);


Digits:=35:
A:= evalf(collect(A/poly_norm_opt(A,t),t),7): #to match output

#NOTE: USING 7 DIGITS SINCE THE PAPER USES 7 to DISPLAY

K_init := evalf(rescale_columns(evalf(K_init),t),7); #note that the kernel vector is only #accurate to 10 decimal points!!!




my_soln:= singular_poly_sqp_dbg( (A+A_noise),DA,DA_vars,(A+A_noise),(K_init),10,1e-25,1e14,"sln"):


evalb(sqrt(my_soln[1]) <  poly_norm_opt(A_noise,t));

#printf("The optimization resulted in a better point: %s" ,evalb(sqrt(my_soln[1]) < poly_norm_opt(A_noise,t)));
DA_final := my_soln[2]:
B_ker_final := (my_soln[3]);
my_soln[4]:

#poly_norm_opt(DA_final-A_noise,t);
poly_norm_opt(DA_final,t)/poly_norm_opt(evalf(A),t);
poly_norm_opt(A_noise,t)/poly_norm_opt(evalf(A),t);
poly_norm_opt( (A +A_noise+ DA_final).B_ker_final,t);

poly_norm_opt( (A).K_init,t);


evalf(collect(A+A_noise,t),7);
latex(%); 
evalf(collect(A,t),7);
latex(%);

evalf(K_init,7);
latex(%);


evalf(subs(my_soln[4],DA),7);
latex(%);
poly_norm_opt(subs(my_soln[4],DA),t);

evalf(B_ker_final,7);
latex(%);

A:=A+A_noise;

#get A0
evalf(subs(t=0,A),7);
latex(%);


#get A1
evalf(subs(t=0,Matrix(A,(i,j) -> diff(A[i,j],t))),7);
latex(%);

#get A2
evalf(subs(t=0,Matrix(A,(i,j) -> 1/2*diff(A[i,j],t$2))),7);
latex(%);

#get A3
evalf(subs(t=0,Matrix(A,(i,j) -> 1/6*diff(A[i,j],t$3))),7);
latex(%);




#get A0
evalf(subs(t=0,subs(my_soln[4],DA)),7);
latex(%);


#get A1
evalf(subs(t=0,Matrix(A,(i,j) -> diff(subs(my_soln[4],DA[i,j]),t))),7);
latex(%);

#get A2
evalf(subs(t=0,Matrix(A,(i,j) -> 1/2*diff(subs(my_soln[4],DA[i,j]),t$2))),7);
latex(%);

#get A3
evalf(subs(t=0,Matrix(A,(i,j) -> 1/6*diff(subs(my_soln[4],DA[i,j]),t$3))),7);
latex(%);





