
read("../../../lib/nearest_singular_poly_functions.mpl"):
read("../../../lib/alpha_optimization.mpl"): #needed for Levenberg-Marquardt
read("../../../lib/nearest_smith_functions.mpl"): #needed for approximate GCD

with(NearestPoly):
with(AlphaOptimization):
with(NearestSmith):

read("../../../lib/numeric_poly_linalg.mpl"): #needed for some kernel stuff

read("../../../lib/SQP_solvers.mpl"): #Needed for SLN-newton

A:= <t+1,t-3,t,t-1| t+2,1,3,t-4>.<t+3,1|t^2-1,t-1|4,t+8|t-1,t+1>: #does not "work" for a queer reason



A := Matrix(4, 4, [[55*t^3-87*t^2-36*t+54, 30*t^3+56*t^2+70*t-56, 30*t^3-4*t^2+78*t-32, -39*t^3-28*t^2-23*t-14], [-16*t^3-27*t^2+84*t-9, 35*t^3-t^2-76*t+24, -2*t^3-8*t^2-30*t-24, -27*t^3+27*t^2-4*t+6], [44*t^3+53*t^2-195*t+30, -145*t^3-102*t^2+216*t-48, -2*t^3-18*t^2+84*t+16, 117*t^3+22*t-12], [62*t^3-37*t^2-63*t-42, 35*t^3-2*t^2-20*t+32, 34*t^3+14*t^2+64*t+48, -45*t^3+12*t^2+20*t+8]]); A_norm := evalf(A/poly_norm_opt(A, t), 2);



b1:=Vector[column](4, [0.4069413942009080e-2*t*(15.*t^3+17.*t^2-74.*t+4.), .2319565946945176*t^4-0.9359652066620885e-1*t^3-.3336919432447445*t^2-0.8545769278219068e-1*t-0.2441648365205449e-1, 0., .2645119062305902*t^4+0.3255531153607264e-1*t^3-.7894663047497616*t^2+.1220824182602724*t+0.9766593460821792e-1]);

b2:=Vector[column](4, [-.1175675321427321*t^4-.1018918611903678*t^3-.1724323804760071*t^2-.3135134190472857*t+.2508107352378286, -0.3918917738091071e-1*t^4-0.7837835476182143e-1*t^3+.2194593933331000*t^2-.1645945449998249*t+.1881080514283715, .2547296529759196*t^4+0.3135134190472857e-1*t^3-.7602700411896679*t^2+.1175675321427321*t+0.9405402571418572e-1, 0.]);


poly_norm_opt(A.<b1|b2>,t); #this is an approximate kernel verification

K_init := <b1|b2>;


m,n := LinearAlgebra:-Dimension(K_init):



poly_norm_opt(A.K_init,t); #it is indeed a kernel!


DA, DA_vars := generate_unstructured_perturbation(A, t,'QQ'): #less QQ more pew pew?
default_DeltaA_pt:= [seq(DA_vars[i]=0,i=1..nops(DA_vars))]:

with(LinearAlgebra):

A_noise := subs(random_pt(DA_vars),DA):

A_noise := A_noise/evalf(poly_norm_opt(A_noise,t)) *.05: #1e-7 works...
#quit;

#A_noise := evalf(collect(A,t),2) * 1e-1;

poly_norm_opt(A_noise,t);
poly_norm_opt(A,t);



#K_init := `<|>`(op(NullSpace(A)));
#K_init :=collect(simplify( K_init * denom(K_init[2,1])),t);



K_init := evalf(K_init);
poly_norm_opt(A.K_init,t);


Digits:=35:
A:= evalf(collect(A/poly_norm_opt(A,t),t),7): #to match output

#NOTE: USING 7 DIGITS SINCE THE PAPER USES 7 to DISPLAY

K_init := evalf(rescale_columns(evalf(K_init),t),7); #note that the kernel vector is only #accurate to 10 decimal points!!!




my_soln:= singular_poly_sqp_dbg( (A+A_noise),DA,DA_vars,(A+A_noise),(K_init),100,1e-25,1e14,"lm"):


evalb(sqrt(my_soln[1]) <  poly_norm_opt(A_noise,t));

#printf("The optimization resulted in a better point: %s" ,evalb(sqrt(my_soln[1]) < poly_norm_opt(A_noise,t)));
DA_final := my_soln[2]:
B_ker_final := (my_soln[3]);
my_soln[4]:

poly_norm_opt(DA_final-A_noise,t);
poly_norm_opt(DA_final,t)/poly_norm_opt(evalf(A),t);
poly_norm_opt(A_noise,t)/poly_norm_opt(evalf(A),t);
poly_norm_opt( (A +A_noise+ DA_final).B_ker_final,t);

poly_norm_opt(B_ker_final - K_init,t);

poly_norm_opt( (A).K_init,t);


evalf(collect(A+A_noise,t),7);
latex(%); 
evalf(collect(A,t),7);
latex(%);

evalf(K_init,7);
latex(%);


evalf(subs(my_soln[4],DA),7);
latex(%);
poly_norm_opt(subs(my_soln[4],DA),t);

evalf(B_ker_final,7);
latex(%);

A:=A+A_noise;

#get A0
evalf(subs(t=0,A),7);
latex(%);


#get A1
evalf(subs(t=0,Matrix(A,(i,j) -> diff(A[i,j],t))),7);
latex(%);

#get A2
evalf(subs(t=0,Matrix(A,(i,j) -> 1/2*diff(A[i,j],t$2))),7);
latex(%);

#get A3
evalf(subs(t=0,Matrix(A,(i,j) -> 1/6*diff(A[i,j],t$3))),7);
latex(%);




#get A0
evalf(subs(t=0,subs(my_soln[4],DA)),7);
latex(%);


#get A1
evalf(subs(t=0,Matrix(A,(i,j) -> diff(subs(my_soln[4],DA[i,j]),t))),7);
latex(%);

#get A2
evalf(subs(t=0,Matrix(A,(i,j) -> 1/2*diff(subs(my_soln[4],DA[i,j]),t$2))),7);
latex(%);

#get A3
evalf(subs(t=0,Matrix(A,(i,j) -> 1/6*diff(subs(my_soln[4],DA[i,j]),t$3))),7);
latex(%);




