read("../../../lib/alpha_optimization.mpl"):
with(AlphaOptimization);
read("../../../lib/nearest_singular_poly_functions.mpl"):
read("../../../lib/nearest_smith_functions.mpl"):
#with(NearestPoly);
with(NearestSmith);
read("../../../lib/rank-factor-lib.mpl");





with(NearestPoly):
with(AlphaOptimization):
with(NearestSmith):
with(DETools):
read("../../../lib/numeric_poly_linalg.mpl"): #needed for some kernel stuff
read("../../../lib/SQP_solvers.mpl"); #needed for some minimal embedding stuff.
with(PolynomialTools):
with(LinearAlgebra):
read("approxore_functions.mpl"): #legacy approximate GCRD functions.




R:=[Dt,t]:

f:= 0.769e-2*Dt^5+(0.35e-3*t^2-0.5386e-1+0.5386e-1*t)*Dt^4+(-.16928*t+0.140e-2*t^3+.17313+0.6820e-1*t^2)*Dt^3+(.16928*t+.22559*t^2-.33472-0.9513e-1*t^3)*Dt^2+(.18607*t^3-.65720*t^2-0.4617e-1*t+.32702)*Dt-0.769e-2*t-0.9234e-1*t^3+.36305*t^2-.11927;


g:= (0.1001e-1*t-0.1001e-1)*Dt^5+(0.4019e-1*t^2-0.7007e-1*t+0.3003e-1)*Dt^4+(0.63e-3*t^3-0.1048e-1*t^2+.15014*t-.11010)*Dt^3+(.27901*t^3-.32921*t^2-0.9008e-1*t+.17016)*Dt^2+(-.55990*t^3+.52909*t^2-0.4004e-1*t-0.8007e-1)*Dt+.28026*t^3-.22959*t^2+0.4004e-1*t; 


fstar_init := 0.8287e-1*Dt^2+(0.377e-2*t^2+.24862*t-.33150)*Dt+.91162*t-0.4144e-1-8.95580*10^(-10)*t^3-.24862*t^2 :

gstar_init := (.10780*t-.10780)*Dt^2+(0.168e-2*t^2+7.62839*10^(-10)*t+2.48813*10^(-8))*Dt-.43122*t+1.04093*10^(-7)+1.02149*10^(-7)*t^3+.75463*t^2:

h_init := 0.9285e-1*Dt^3+(.37139*t-.27854)*Dt^2+(-.74278*t+.27854)*Dt+.37139*t-0.9285e-1:

f_init := simplify(mult(fstar_init,h_init,R)):
g_init := simplify(mult(gstar_init,h_init,R)):



DeltaF,DeltaF_vars := 
NearestSmith:-generate_perturbation(convert(PolynomialTools:-CoefficientVector(f,Dt),Matrix),t,"entry",ff):
DeltaG,DeltaG_vars := 
NearestSmith:-generate_perturbation(convert(PolynomialTools:-CoefficientVector(g,Dt),Matrix),t,"entry",gg):



f_vec := PolynomialTools:-CoefficientVector(f,Dt):
g_vec := PolynomialTools:-CoefficientVector(g,Dt):

finit_vec := PolynomialTools:-CoefficientVector(f_init,Dt):


ginit_vec := PolynomialTools:-CoefficientVector(g_init,Dt):



#need to write better initial guess code here!

#proc: vectorize_structire
#Input: polynomial f, Ansatz polynomial DeltaF
#Output: f vectorized based on the degree pattern of  Deltaf
#Notes: Used to compute an initial guess by padding stuff with zero entries. 
#Notes: Fits the guess using least-squares
compute_guess := proc(f, Deltaf,x:=t)
    local i,
        my_eqns,
        f_vec,
        my_size,
        df_vec;
    
    my_eqns := []; #empty list for now
    for i from 1 to ArrayNumElems(f) do 
        f_vec := PolynomialTools:-CoefficientVector(f(i),x);
        df_vec := PolynomialTools:-CoefficientVector(Deltaf(i),x);
        my_size := max(ArrayNumElems(f_vec), ArrayNumElems(df_vec));
        
        df_vec := Vector(df_vec,my_size);
        f_vec := Vector(f_vec,my_size); #make sure degrees are generic.
        my_eqns := [op(my_eqns), op(Equate(df_vec,f_vec)) ];
    od: 
    
    return my_eqns;
end proc:

#compute_guess(finit_vec,DeltaF,t);

#DeltaF_init := NearestPoly:-vectorize(convert(DeltaF,Vector)-f_vec+f_init,t):
#DeltaG_init := NearestPoly:-vectorize(convert(DeltaG,Vector)-g_vec+g_init,t):

#DeltaF_init_pt := op(solve(Equate(DeltaF_init,Vector(ArrayNumElems(DeltaF_init))),DeltaF_vars));
#DeltaG_init_pt := op(solve(Equate(DeltaG_init,Vector(ArrayNumElems(DeltaG_init))),DeltaG_vars));


DeltaF_init_pt := compute_guess(finit_vec-f_vec,DeltaF,t);
DeltaG_init_pt := compute_guess(ginit_vec-g_vec,DeltaG,t);





#these systems may not be consistent, but who cares right now.
DeltaF:= PolynomialTools:-FromCoefficientVector(convert(DeltaF,Vector),Dt):
DeltaG:= PolynomialTools:-FromCoefficientVector(convert(DeltaG,Vector),Dt):


X_init := [op(DeltaF_init_pt), op(DeltaG_init_pt)]:

#test initial guess
poly_norm_opt(f_vec-finit_vec,t)^2+
poly_norm_opt(g_vec-ginit_vec,t)^2;

OreNorm(subs(X_init,DeltaG),R,2)^2+OreNorm(subs(X_init,DeltaF),R,2)^2;




S:= LinearAlgebra:-Transpose(DifferentialVandermonde(f+DeltaF,g+DeltaG,R)): #we implicitly know the degree of h



X_default := [seq(DeltaF_vars[i]=0,i=1..nops(DeltaF_vars)),seq(DeltaG_vars[i]=0,i=1..nops(DeltaG_vars)) ]:

m,n := LinearAlgebra:-Dimension(S);
d := matrix_degree(S,t);


kernel_degree_bound := (n-3)*d+1-17;

#put in the degree of h here as a magic #
S_lin,b_lin := NearestPoly:-linearize_A_bound(S,t,kernel_degree_bound):


S_nil := subs(X_default,S):
DeltaS:= S-S_nil;


#TODO: Try the rank factorization.

X:= [op(DeltaF_vars), op(DeltaG_vars)]:
X_init := [op(DeltaF_init_pt), op(DeltaG_init_pt)]:


rank_def :=0:

interface(printbytes=false):

my_soln := PolyRankFactor:-nearest_singular_poly_rf(S_nil,subs(X_init,S),t,DeltaS,X,kernel_degree_bound,rank_def,1e-12,true,false)[2]:





subs(my_soln,DeltaF);

latex(%);

subs(my_soln,DeltaG);

latex(%);


obj := poly_norm_opt(PolynomialTools:-CoefficientVector(DeltaF,Dt),t)^2+poly_norm_opt(PolynomialTools:-CoefficientVector(DeltaG,Dt),t)^2:


subs(my_soln,obj);

sqrt(%);


subs(my_soln,S_lin);
LinearAlgebra:-Rank(%);


subs(t=1,subs(my_soln,S));
LinearAlgebra:-SingularValues(%);




quit;

