read("../../../lib/alpha_optimization.mpl"):
with(AlphaOptimization);
read("../../../lib/nearest_singular_poly_functions.mpl"):
read("../../../lib/nearest_smith_functions.mpl"):
#with(NearestPoly);
with(NearestSmith);
read("../../../lib/rank-factor-lib.mpl");





with(NearestPoly):
with(AlphaOptimization):
with(NearestSmith):
with(DETools):
read("../../../lib/numeric_poly_linalg.mpl"): #needed for some kernel stuff
read("../../../lib/SQP_solvers.mpl"); #needed for some minimal embedding stuff.
with(PolynomialTools):
with(LinearAlgebra):
read("approxore_functions.mpl"): #legacy approximate GCRD functions.




R:=[Dt,t]:

f:=(.11329*t^6+.23414*t^5+.12840*t^4+0.755e-2*t^3+0.5e-4)*Dt^3+(0.1e-4*t^6+.23414*t^5+.59667*t^4+0.2269e-1*t^3-0.4528e-1*t^2-0.2266e-1*t+3.67436*10^(-7))*Dt^2+(-.11329*t^6+.33231*t^5-.43054*t^4-0.754e-2*t^3-0.3e-4*t^2-0.6798e-1*t+0.3e-4)*Dt-0.1e-4*t^6-.23414*t^5+.34741*t^4+0.1510e-1*t^3-0.6799e-1*t^2+0.9064e-1*t+0.4e-4:


g:= (0.1938e-1*t^4-0.3876e-1*t^3-0.7752e-1*t^2+0.3876e-1*t+0.5819e-1)*Dt^3+(.13567*t^4+.23252*t^3-0.7750e-1*t^2-.34879*t+.29066)*Dt^2+(-0.1938e-1*t^4+.13563*t^3+0.3873e-1*t^2+.25195*t-.23257)*Dt-.13562*t^4+.44570*t^3-.56198*t^2-0.3874e-1*t+.17439:


f_init := 7.81664*10^(-7)*t^8*Dt^2-5.66435*10^(-7)*t^7*Dt-3.33148*10^(-7)*t^8*Dt+3.33124*10^(-7)*t^8*Dt^3+0.*(t^7)-7.81720*10^(-7)*t^8+(0.*(t^7))*Dt^3+.11329*t^6*Dt^3+.23414*t^5*Dt^3+.12842*t^4*Dt^3+0.757e-2*t^3*Dt^3-.11329*t^6*Dt+.33232*t^5*Dt-.43054*t^4*Dt-0.753e-2*t^3*Dt+0.1e-4*t^6*Dt^2+.23415*t^5*Dt^2+.59666*t^4*Dt^2+0.2268e-1*t^3*Dt^2-0.4529e-1*t^2*Dt^2+0.1e-4*t^2*Dt^3+8.33124*10^(-7)*Dt^3+(0.*(t^7))*Dt^2-0.6797e-1*t*Dt-0.2267e-1*t*Dt^2-0.1e-4*t^2*Dt+.34741*t^4-.23413*t^5+0.1510e-1*t^3-0.6798e-1*t^2+(0.*t)*Dt^3-0.1e-4*t^6+0.*(Dt^2)+0.9064e-1*t+0.1e-4-0.1e-4*Dt:


g_init := 0.*(t^6)+.17441+0.1e-4*t^5*Dt^3+0.1938e-1*t^4*Dt^3-0.3876e-1*t^3*Dt^3+0.1e-4*t^5*Dt-0.1939e-1*t^4*Dt+.13563*t^3*Dt+.13566*t^4*Dt^2+.23253*t^3*Dt^2-0.7751e-1*t^2*Dt^2+0.3875e-1*t*Dt^3-0.7751e-1*t^2*Dt^3+(0.*(t^6))*Dt^3-(0.*(t^6))*Dt+.25195*t*Dt-.34879*t*Dt^2+0.3873e-1*t^2*Dt-.13563*t^4-0.1e-4*t^5+.44569*t^3-.56198*t^2-(0.*(t^6))*Dt^2+(0.*(t^5))*Dt^2-0.3874e-1*t-.23256*Dt+.29067*Dt^2+0.5814e-1*Dt^3:

DeltaF,DeltaF_vars := 
NearestSmith:-generate_perturbation(convert(PolynomialTools:-CoefficientVector(f,Dt),Matrix),t,"entry",ff):
DeltaG,DeltaG_vars := 
NearestSmith:-generate_perturbation(convert(PolynomialTools:-CoefficientVector(g,Dt),Matrix),t,"entry",gg):



f_vec := PolynomialTools:-CoefficientVector(f,Dt):
g_vec := PolynomialTools:-CoefficientVector(g,Dt):

finit_vec := PolynomialTools:-CoefficientVector(f_init,Dt):


ginit_vec := PolynomialTools:-CoefficientVector(g_init,Dt):



#need to write better initial guess code here!

#proc: vectorize_structire
#Input: polynomial f, Ansatz polynomial DeltaF
#Output: f vectorized based on the degree pattern of  Deltaf
#Notes: Used to compute an initial guess by padding stuff with zero entries. 
#Notes: Fits the guess using least-squares
compute_guess := proc(f, Deltaf,x:=t)
    local i,
        my_eqns,
        f_vec,
        my_size,
        df_vec;
    
    my_eqns := []; #empty list for now
    for i from 1 to ArrayNumElems(f) do 
        f_vec := PolynomialTools:-CoefficientVector(f(i),x);
        df_vec := PolynomialTools:-CoefficientVector(Deltaf(i),x);
        my_size := max(ArrayNumElems(f_vec), ArrayNumElems(df_vec));
        
        df_vec := Vector(df_vec,my_size);
        f_vec := Vector(f_vec,my_size); #make sure degrees are generic.
        my_eqns := [op(my_eqns), op(Equate(df_vec,f_vec)) ];
    od: 
    
    return my_eqns;
end proc:

#compute_guess(finit_vec,DeltaF,t);

#DeltaF_init := NearestPoly:-vectorize(convert(DeltaF,Vector)-f_vec+f_init,t):
#DeltaG_init := NearestPoly:-vectorize(convert(DeltaG,Vector)-g_vec+g_init,t):

#DeltaF_init_pt := op(solve(Equate(DeltaF_init,Vector(ArrayNumElems(DeltaF_init))),DeltaF_vars));
#DeltaG_init_pt := op(solve(Equate(DeltaG_init,Vector(ArrayNumElems(DeltaG_init))),DeltaG_vars));


DeltaF_init_pt := compute_guess(finit_vec-f_vec,DeltaF,t);
DeltaG_init_pt := compute_guess(ginit_vec-g_vec,DeltaG,t);





#these systems may not be consistent, but who cares right now.
DeltaF:= PolynomialTools:-FromCoefficientVector(convert(DeltaF,Vector),Dt):
DeltaG:= PolynomialTools:-FromCoefficientVector(convert(DeltaG,Vector),Dt):


X_init := [op(DeltaF_init_pt), op(DeltaG_init_pt)]:

#test initial guess
poly_norm_opt(f_vec-finit_vec,t)^2+
poly_norm_opt(g_vec-ginit_vec,t)^2;

OreNorm(subs(X_init,DeltaG),R,2)^2+OreNorm(subs(X_init,DeltaF),R,2)^2;


S:= LinearAlgebra:-Transpose(DifferentialVandermonde(f+DeltaF,g+DeltaG,R)): #we implicitly know the degree of h



X_default := [seq(DeltaF_vars[i]=0,i=1..nops(DeltaF_vars)),seq(DeltaG_vars[i]=0,i=1..nops(DeltaG_vars)) ]:

m,n := LinearAlgebra:-Dimension(S);
d := matrix_degree(S,t);


kernel_degree_bound := (n-2)*d+1-16;

#put in the degree of h here as a magic #
S_lin,b_lin := NearestPoly:-linearize_A_bound(S,t,kernel_degree_bound):






#TODO: Try the rank factorization.

X:= [op(DeltaF_vars), op(DeltaG_vars)]:
X_init := [op(DeltaF_init_pt), op(DeltaG_init_pt)]:
S_nil := subs(X_default,S):

DeltaS:= S-S_nil:

LinearAlgebra:-Rank(subs(X_init,S_lin));
LinearAlgebra:-Dimension(S_lin);

#SV:=LinearAlgebra:-SingularValues(subs(X_init,S_lin));

#interface(rtablesize=300);
#SV;


rank_def :=0:

interface(printbytes=false):



#do not project down
my_soln := PolyRankFactor:-nearest_singular_poly_rf(S_nil,subs(X_init,S),t,DeltaS,X,kernel_degree_bound,rank_def,1e-12,true,false)[2]:




subs(my_soln,DeltaF);

latex(%);

subs(my_soln,DeltaG);

latex(%);


obj := poly_norm_opt(PolynomialTools:-CoefficientVector(DeltaF,Dt),t)^2+poly_norm_opt(PolynomialTools:-CoefficientVector(DeltaG,Dt),t)^2;


subs(my_soln,obj);

sqrt(%);



subs(my_soln,S_lin);
LinearAlgebra:-Rank(%);

S_lin,b_lin := NearestPoly:-linearize_A_bound(S,t,(n-2)*d+1):

LinearAlgebra:-Rank(subs(my_soln,S_lin));
LinearAlgebra:-Dimension(S_lin);





quit;

