read("../lib/alpha_optimization.mpl"):
with(AlphaOptimization):
read("../lib/nearest_singular_poly_functions.mpl"):
read("../lib/nearest_smith_functions.mpl"):
with(NearestPoly):
with(NearestSmith):
with(DETools):
read("../lib/numeric_poly_linalg.mpl"): #needed for some kernel stuff
read("../lib/SQP_solvers.mpl"); #needed for some minimal embedding stuff.
with(PolynomialTools):
with(LinearAlgebra):



A:= <1,t,t|0,1,t|0,0,1>;


m,n := LinearAlgebra:-Dimension(A);
d:= matrix_degree(A,t);



U_degree_bound := matrix_degree(A,t);

U := Matrix(n,n, (i,j)-> add( u[i,j,k]*t^k, k=0..U_degree_bound ) );





U_vars := [seq(seq(seq(u[i,j,k], k= 0..U_degree_bound), j=1..n),i=1..n)];



U_vars := convert(`<,>`(seq(  Vector(PolynomialTools:-CoefficientVector(U(i),t),d+1), i=1..ArrayNumElems(U))),list);
A_vars := convert(`<,>`(seq(  Vector(PolynomialTools:-CoefficientVector(U(i)-A(i),t),d+1), i=1..ArrayNumElems(U))),list);
A_pt := [op(solve(A_vars,U_vars))];







det_vec:= Vector(PolynomialTools:-CoefficientVector(LinearAlgebra:-Determinant(U),t),n*d+1);

J_det := VectorCalculus:-Jacobian(det_vec,U_vars);


U_adj := LinearAlgebra:-Transpose(LinearAlgebra:-Adjoint(U));
U_adj_vec := LinearAlgebra:-Transpose(Matrix(convert(U_adj,Vector)));

J_det_manual := linearize_A_bound(U_adj_vec,t,d+1)[1];
J_det_manual-J_det;

norm(%,1);



U_adj_mat := LinearAlgebra:-Adjoint(U);
U_adj := convert(LinearAlgebra:-Adjoint(U),Vector);
U_adj_vec := convert(`<,>`(seq(  Vector(PolynomialTools:-CoefficientVector(U_adj_mat(i),t),(n-1)*d+1), i=1..ArrayNumElems(U))),Vector);

U_vec := convert(`<,>`(seq(  Vector(PolynomialTools:-CoefficientVector(U(i),t),d+1), i=1..ArrayNumElems(U_adj))),Vector);


J_adj := VectorCalculus:-Jacobian(U_adj_vec,convert(U_vec,list));


Ident := LinearAlgebra:-IdentityMatrix(n);

my_lhs := linearize_A_bound( LinearAlgebra:-KroneckerProduct(Ident,U),t, (n-1)*d+1 )[1];

my_rhs := 
        convert(Ident,Vector) . LinearAlgebra:-Transpose(convert( LinearAlgebra:-Transpose(U_adj_mat),Vector))
        - LinearAlgebra:-KroneckerProduct(LinearAlgebra:-Transpose(U_adj_mat),Ident);
        
my_rhs := linearize_A_bound(my_rhs,t,d+1)[1];

(my_lhs).J_adj;
my_rhs;

%-%%;

norm(%,1);


my_lhs;

lhs_init:= subs(op(A_pt),my_lhs);
Rank(%);
rhs_init:= subs(op(A_pt),my_rhs);
Rank(%);

my_J:= LinearSolve(lhs_init,rhs_init,free='QQ');

lhs_inv := LinearAlgebra:-MatrixInverse(lhs_init, method=pseudo);

J_alt := lhs_inv . rhs_init;


subs(QQ=0,my_J - subs(op(A_pt),J_adj));
norm(%,1);


J_alt - subs(op(A_pt),J_adj);
norm(%,1);


LinearAlgebra:-Rank(J_alt);
LinearAlgebra:-Dimension(J_alt);


