
ProjectedRankFactor:= module()

option package;
export nearest_singular_poly_projected_rf;



#proc: compute_initial_guess_projected_rf_real
#Input: A, 
#   initial guess for A
#   indeterminant in t
#   perturbation structure for A
#   variables for perturbation structure
#   Degree bound for the determinant of A or largest non-vanishing generic minor. Generic bound is $nd$
#Output: Parses the input into a list of variables and points for an initial guess.
#Notes: This is a helper function to parse input from the user and use the SVD to automatically compute quantities. It does not strictly compute a feasible point (it does automatically truncate the SVD if required). 
#Notes: This function assumes that the evaluation points are real. This is probably very bad.

compute_initial_guess_pojected_rf := proc(A,A_init,t,DeltaA,DA_vars,det_bound,desired_rank)
        local   Omega, #list of roots
                A_init_images, #list of A_init evaluated at omega
                U_list, V_list, #list of U's and V's
                U_vars, V_vars, #list of U and V vars 
                imag_u_vars, imag_v_vars, real_u_vars,real_v_vars,
                AA_init, #temp variables for a "for loop"
                U_init_list,V_init_list,U_init_pt,V_init_pt,
                i,j,m,n,d,R,
                DA_init,cf_vec,cf_mat,
                U_init,V_init,S_init,A_rank,Sigma, #list of the result of the SVD on several images.
                X_init; #stuff to return...
                ;
              
              m,n := LinearAlgebra:-Dimension(A);
              d := matrix_degree(A,t);
              
              
              #call a routine from legacy functions
                DA_init := NearestPoly:-generate_initial_point(A,A_init,DeltaA,t):
                
                cf_vec,cf_mat := LinearAlgebra:-GenerateMatrix(DA_init, DA_vars);
                
                DA_init := Equate(convert(DA_vars,Vector),Optimization:-LSSolve([cf_mat,cf_vec])[2]);
              
            
              
              Omega := [seq( evalf(exp(2*Pi*I*i/(det_bound+1))), i= 0..det_bound) ];
              
            #  print(Omega);
           
               #Omega := [seq(i+1, i= 0..det_bound)];
           
              U_list := [seq(Matrix(m,desired_rank, (i,j)->uu[i,j,k]+ I*Imu[i,j,k]) , k=0..det_bound ) ];
              
         
              V_list := [seq(Matrix(desired_rank,n, (i,j)->vv[i,j,k] +I*Imv[i,j,k]) , k=0..det_bound ) ];
                   
#              print(U_list);
#              print(V_list);
              real_u_vars := [seq(op(convert(Re(U_list[j]),list)),j=1..nops(U_list))] assuming real;
              imag_u_vars := [seq(op(convert(Im(U_list[j]),list)),j=1..nops(U_list))] assuming real;
              
              
              real_v_vars := [seq(op(convert(Re(V_list[j]),list)),j=1..nops(V_list))] assuming real;
              imag_v_vars := [seq(op(convert(Im(V_list[j]),list)),j=1..nops(V_list))] assuming real;
              
              
              U_vars := [op(real_u_vars), op(imag_u_vars)];
              V_vars := [op(real_v_vars), op(imag_v_vars)];
              
             A_init_list := [seq((evalc(subs(t=Omega[j], A+DeltaA))), j=1..nops(Omega))];
             U_init_list := [];
             V_init_list := [];
              
              
              #I know for loops suck,but I don't want to write a triple nested seq or something
              for j from 1 to nops(Omega) do
                    #get initial point
                    AA_init := (subs(subs(DA_init,A_init_list[j])));
                    
                    U_init,S_init,V_init := LinearAlgebra:-SingularValues(AA_init, output=['U','S','Vt']);
                    

                    
                    
                    #figure out rank here. Can do some form of compression if needed.
                    Sigma := LinearAlgebra:-DiagonalMatrix(S_init[1..LinearAlgebra:-ColumnDimension(A)], shape=diagonal):
                    #print(Sigma);
                    #A_rank := LinearAlgebra:-Rank(Sigma); #lazy me!

                    #printf("Image %d has rank %d\n",j, A_rank);
                    
                    #take the smallest between the  compression
                    #and bound provided by the user.
                    #R := min(A_rank, desired_rank );
                    R := desired_rank;
                    #do not do compressions for now.
                   # if always_decrease = true then
                    #    R := min(A_rank-1, desired_rank );
                   # fi:
                    Sigma := Sigma[1..R, 1..R];

                    U_init :=  (U_init)[1..LinearAlgebra:-RowDimension(U_list[j]),1..LinearAlgebra:-ColumnDimension(U_list[j])];
                    
                    #need to re-scale by singular values for 
                    V_init := Sigma.V_init[1..LinearAlgebra:-RowDimension(V_list[j]), 1 .. LinearAlgebra:-ColumnDimension(V_list[j])] ; #because this is the transpose
                    
                    
                    #split up the real and imaginary parts.
                    

                    
                    U_init_pt := Equate( Re(evalc(U_list[j])),Re(evalc(U_init))) assuming real:
                    
                    
                    U_init_pt := [op(U_init_pt), op(Equate( Im(evalc(U_list[j])),Im(evalc(U_init)))) ] assuming real;
                    
                    
                    
                    
                    V_init_pt := Equate( Re(evalc(V_list[j])),Re(evalc(V_init))) assuming real:
                    V_init_pt := [op(V_init_pt), op(Equate( Im(evalc(V_list[j])),Im(evalc(V_init)))) ] assuming real;
                    
                    U_init_list := [op(U_init_list),op(U_init_pt)];
                    V_init_list := [op(V_init_list),op(V_init_pt)];
                    
              od:   
            
            X:= [op(DA_vars), op(U_vars),op(V_vars)];
            X_init := [op(DA_init), op(U_init_list), op(V_init_list)];
            
            return A_init_list,U_list,V_list,X_init,X;
              
            
end proc:








#Proc: nearest_singular_poly_projected_rf
#Input: Matrix polynomial A, 
#       Initial guess of a singular matrix polynomial
#       Perturbation structure Delta A
#       list of variables for Delta A
#       indeterminant t
#       the desired rank for the approximation
#Output: A nearby rank desired_rank matrix polynomial with structure DeltaA or an indication of failure
#Notes: We will attempt to automate most of the procedure here. 
#       Several calls to quasi-Newton methods will be required in order to solve this problem.
#Computes a few initial guesses if needed...
#this calls a modified LM with some explicit function computation. 

#this function is mostly a wrapper...



#this function is mostly a wrapper...
nearest_singular_poly_projected_rf :=proc(A,A_init,t,DeltaA,DA_vars, det_bound,desired_rank,tol:=1e-10,method:="lm",project_feasible:=true,max_iter := 100, starting_param := 1e-10)
        local   my_guess,
                X_init,X,
                Lambda,Lambda_init,
                Z,Z_init,
                A_init_list,U_list,V_list,
                constraints,
                L, residuals,
                my_soln,
                t_start;
                ;
        
                    
                printf("Computing initial guesses\n");
                t_start := time();
                my_guess :=     compute_initial_guess_pojected_rf(A,A_init,t,DeltaA,DA_vars,det_bound,desired_rank):
                printf("Initial guess computed in %f seconds\n",time()-t_start);
                
                A_init_list,U_list,V_list,X_init,X := my_guess;
                
                

                constraints := [seq( op(convert(Re(evalc(A_init_list[j] - U_list[j].V_list[j])),list)) , j=1..nops(A_init_list))] assuming real:



                constraints := [op(constraints), seq( op(convert(Im(evalc( A_init_list[j]- U_list[j].V_list[j])),list)) , j=1..nops(A_init_list))] assuming real:


                constraints := convert(constraints,Vector);
                
                if project_feasible = true and norm(subs(X_init,residuals),2) > 1e-8 then
                    t_start := time();
                    printf("Projecting initial guess to feasible point...\n");
                    X_init := levenberg_marquardt_implicit_merit(constraints,X,X_init,tol,max_iter,1e-10)[2]:    
                    printf("Feasible point computed in %f seconds\n", time()-t_start);
                fi:
                
                 
                printf("Computing Lagrange multipliers...\n");
                t_start := time();
                Lambda,Lambda_init := op(initial_guess_lagrangian_projected_rf(constraints,DA_vars,X,X_init));

                
                printf("Lagrange multipliers computed in %f seconds.\n", time()-t_start);
                
                t_start := time();
                L:= poly_norm_opt(convert(DA_vars,Vector),t)^2+ LinearAlgebra:-Transpose(Lambda) . constraints;

                Z:= [op(X),op(convert(Lambda,list))];
                Z_init := [op(X_init), op(Lambda_init)];
                
                
                residuals := VectorCalculus:-Gradient(L,Z);
                
                
                if method = "lm" then 
                printf("Beginning Quasi-Newton method.\n");

                    my_soln := levenberg_marquardt_implicit_merit(residuals,Z,Z_init,tol,max_iter,starting_param)[2]:
                
                else
                    printf("Beginning Vanilla Newton method.\n");

                    my_soln := newton_vanilla(residuals,Z,Z_init,tol,max_iter)[2]:
                
                fi:
                
                
                printf("Stationary point computed in %f seconds\n",time()-t_start);
                
                return my_soln;
           
       
end proc:






#Proc: compute_lagrange_multipliers
#Proc: initial_guess_lagrangian
#Input: stuff we need to compute the Lagrangian (Gradient, initial guess, lambda variables)
#Output: initial guess for Lagrange multipliers (computed via linear least squares approximation)

initial_guess_lagrangian_projected_rf := proc(constraints,DA_vars,X,X_init)
	local lagrangian_system,
	      my_eqns,
	      cf_mat,
	      cf_vec,
	      Gx;
	      ineq_cons,
	      ls_soln,
	      Lambda_init, Lambda,
	      J
	      ; 

	      
    
        #solving a linear system for initial guess
	Lambda := Vector(ArrayNumElems(constraints),j->lambda[j]);
	    Gx := LinearAlgebra:-Transpose(VectorCalculus:-Jacobian(constraints,X)) . Lambda;
	    Gx := Gx+convert(2*<convert(DA_vars,Vector) ,Vector(nops(X)-nops(DA_vars))>,Vector);
	    Gx := subs(X_init,Gx);
        
	lagrangian_system := subs(convert(Gx,Vector));
	
	
	
	my_eqns := Equate(lagrangian_system, Vector(ArrayNumElems(lagrangian_system)));
	cf_mat,cf_vec := LinearAlgebra:-GenerateMatrix(my_eqns,convert(Lambda,list));
	

	
	ls_soln := Optimization:-LSSolve([cf_vec,cf_mat])[2];
	Lambda_init := Equate(convert(Lambda,Vector), ls_soln);

	
	return [Lambda,Lambda_init];
    

end proc:



end module: